﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Net.Sockets;
using System.Threading;
namespace bnlstest
{
    class Program
    {
        static void Main(string[] args)
        {          
            
            #region other data...
            bool connected = false;
            #endregion
            #region initialization

            NetworkStream stream;
            TcpClient tcp;
            tcp = new TcpClient();
            tcp.Connect("127.0.0.1", 9367);
            stream = tcp.GetStream();
            for (int count = 0; count < 3000; count += 200)
            {
                if (tcp.Connected)
                {
                    connected = true;
                    break;
                }
                else
                    Thread.Sleep(200);
            }

            Buffer b = new Buffer();
            Queue<Packet> inQueue = new Queue<Packet>();
            Queue<Packet> outQueue = new Queue<Packet>();
            #endregion

            int cookie = new Random().Next();
            Packet t = new Packet(0x7d, HeaderType.BNLS);
            t.add((byte)0);
            t.add(cookie);
            t.add(new char[4] { 'P', 'X', '3', 'W' });
            t.add((short)4);
            t.add(new byte[] {0xba, 0x1a, 0xe9, 0x43});
            t.add("");
            t.add((byte)0);
            outQueue.Enqueue(t);

            #region update loop

            while (true)
            {
                if (!connected)
                {
                    // connects to bnls server, waits 3 seconds in 200ms intervals to check if connected.

                    Console.WriteLine("Not connected, connecting....");
                    tcp = new TcpClient();
                    tcp.Connect("192.168.1.115", 9367);
                    stream = tcp.GetStream();
                    for (int count = 0; count < 3000; count += 200)
                    {
                        if (tcp.Connected)
                        {
                            connected = true;
                            break;
                        }
                        else
                            Thread.Sleep(200);
                    }
                }


                #region recieve packets

                while (stream.DataAvailable)
                    b.Add((byte)stream.ReadByte());

                if (b.Data.Length >= 3)
                {
                    short packetSize = BitConverter.ToInt16(b.Data, 0);
                    if (b.Data.Length >= packetSize)
                    {
                        byte[] packetData = new byte[packetSize];
                        for (int count = 0; count < packetSize; count++)
                            packetData[count] = b.Data[count];
                        inQueue.Enqueue(new Packet(packetData));
                        b.Data = b.Sub(packetSize, b.Data.Length);
                    }
                }
                #endregion
                #region process packets

                if (inQueue.Count > 0)
                {
                    Packet p = inQueue.Dequeue();
                    Console.WriteLine("recieved:\n" + p.ToString());
                }
                #endregion
                #region send packtets

                while (outQueue.Count > 0)
                {
                    Packet p = outQueue.Dequeue();
                    stream.Write(p.Data, 0, p.Data.Length);
                    Console.WriteLine("sent:\n" + p.ToString());
                }
                #endregion

            #endregion
            }
        }
    }
}
